﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ElfViewerConsole.ELFModel.ELFFormat
{
    class ELFElem16Enum<T> : ELFElem<ushort> where T : struct, IConvertible
    {
        public ELFElem16Enum(long offset, ushort value, string name)
            : base(offset, value, name, typeof(T))
        {
            if (!typeof(T).IsEnum) throw new ArgumentException("T must be an enumerated type");
        }

        public T GetEnumValue()
        {
            return (T)Convert.ChangeType(this.enumValue, typeof(T));
        }
    }
}
