﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ElfViewerConsole.ELFModel.ELFFormat
{
    class ELFElemByteArray : IELFElem
    {
        long offset;
        long length;
        string name;
        byte[] data;

        public ELFElemByteArray(long offset, byte[] data, long length, string name)
        {
            this.offset = offset;
            this.length = length;
            this.name = name;
            this.data = data;
        }

        public object ObjectValue
        {
            get { return data; }
        }

        public long Offset
        {
            get { return offset; }
        }

        public string Name
        {
            get { return name; }
        }

        public string ValueString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("[");
            for (int i = 0; i < length; i++)
            {
                sb.Append(String.Format("{0:X2} ", data[i]));
            }
            //sb.Remove(sb.Length - 1, 1);
            sb.Replace(' ', ']', sb.Length - 1, 1);
            return sb.ToString();
        }

        public string NumValAsAscii()
        {
            return null;
        }

        public string OffsetString
        {
            get { return String.Format("{0:X8}", offset); }
        }

        public int SizeInBytes()
        {
            return (int)length;
        }

        public bool IsEnumValue()
        {
            return false;
        }

        public bool HasEnumFlagsAttibrute()
        {
            return false;
        }

        public Enum GetEnum()
        {
            return null;
        }

        public string GetEnumDescription()
        {
            return "-";
        }
    }
}
