﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace ElfViewerConsole.ELFModel.ELFFormat.Enums
{
    /// <summary>
    /// Information taken from:
    /// http://www.sco.com/developers/gabi/2000-07-17/ch4.eheader.html (2017-11-10)
    /// </summary>
    enum EELFMachine
    {
        [Description("No machine")]
        EM_NONE         = 0,

        [Description("AT&T WE 32100")]
        EM_M32          = 1,

        [Description("SPARC")]
        EM_SPARC        = 2,

        [Description("Intel 80386")]
        EM_386          = 3,

        [Description("Motorola 68000")]
        EM_68K          = 4,

        [Description("Motorola 88000")]
        EM_88K          = 5,

        [Description("Intel 80486")]
        RESERVED        = 6,

        [Description("Intel 80860")]
        EM_860          = 7,

        [Description("MIPS I Architecture")]
        EM_MIPS         = 8,

        [Description("IBM System/370 Processor")]
        EM_S370         = 9,

        [Description("MIPS RS3000 Little-endian")]
        EM_MIPS_RS3_LE  = 10,

        [Description("IBM RS/6000 XXX reserved")]
        EM_IBM_RS6000   = 11,

        [Description("Hewlett-Packard PA-RISC")]
        EM_PARISC       = 15,

        [Description("NCube XXX reserved")]
        EM_NCUBE        = 16,

        [Description("Fujitsu VPP500")]
        EM_VPP500       = 17,

        [Description("Enhanced instruction set SPARC")]
        EM_SPARC32PLUS  = 18,

        [Description("Intel 80960")]
        EM_960          = 19,

        [Description("PowerPC")]
        EM_PPC          = 20,

        [Description("64-bit PowerPC")]
        EM_PPC64        = 21,

        //RESERVED   22-35   Reserved for future use

        [Description("NEC V800")]
        EM_V800         = 36,

        [Description("Fujitsu FR20")]
        EM_FR20         = 37,

        [Description("TRW RH-32")]
        EM_RH32         = 38,

        [Description("Motorola RCE")]
        EM_RCE          = 39,

        [Description("Advanced RISC Machines ARM")]
        EM_ARM          = 40,

        [Description("Digital Alpha")]
        EM_ALPHA        = 41,

        [Description("Hitachi SH")]
        EM_SH           = 42,

        [Description("SPARC Version 9")]
        EM_SPARCV9      = 43,

        [Description("Siemens Tricore embedded processor")]
        EM_TRICORE      = 44,

        [Description("Argonaut RISC Core, Argonaut Technologies Inc.")]
        EM_ARC          = 45,

        [Description("Hitachi H8/300")]
        EM_H8_300       = 46,

        [Description("Hitachi H8/300H")]
        EM_H8_300H      = 47,

        [Description("Hitachi H8S")]
        EM_H8S          = 48,

        [Description("Hitachi H8/500")]
        EM_H8_500       = 49,

        [Description("Intel IA-64 processor architecture")]
        EM_IA_64        = 50,

        [Description("Stanford MIPS-X")]
        EM_MIPS_X       = 51,

        [Description("Motorola ColdFire")]
        EM_COLDFIRE     = 52,

        [Description("Motorola M68HC12")]
        EM_68HC12       = 53,

        [Description("Fujitsu MMA Multimedia Accelerator")]
        EM_MMA          = 54,

        [Description("Siemens PCP")]
        EM_PCP          = 55,

        [Description("Sony nCPU embedded RISC processor")]
        EM_NCPU         = 56,

        [Description("Denso NDR1 microprocessor")]
        EM_NDR1         = 57,

        [Description("Motorola Star*Core processor")]
        EM_STARCORE     = 58,

        [Description("Toyota ME16 processor")]
        EM_ME16         = 59,

        [Description("STMicroelectronics ST100 processor")]
        EM_ST100        = 60,

        [Description("Advanced Logic Corp. TinyJ embedded processor family")]
        EM_TINYJ        = 61,

        // Reserved   62-65   Reserved for future use

        [Description("Siemens FX66 microcontroller")]
        EM_FX66         = 66,

        [Description("STMicroelectronics ST9+ 8/16 bit microcontroller")]
        EM_ST9PLUS      = 67,

        [Description("STMicroelectronics ST7 8-bit microcontroller")]
        EM_ST7          = 68,

        [Description("Motorola MC68HC16 Microcontroller")]
        EM_68HC16       = 69,

        [Description("Motorola MC68HC11 Microcontroller")]
        EM_68HC11       = 70,

        [Description("Motorola MC68HC08 Microcontroller")]
        EM_68HC08       = 71,

        [Description("Motorola MC68HC05 Microcontroller")]
        EM_68HC05       = 72,

        [Description("Silicon Graphics SVx")]
        EM_SVX          = 73,

        [Description("STMicroelectronics ST19 8-bit microcontroller")]
        EM_ST19         = 74,

        [Description("Digital VAX")]
        EM_VAX          = 75,

        [Description("Axis Communications 32-bit embedded processor")]
        EM_CRIS         = 76,

        [Description("Infineon Technologies 32-bit embedded processor")]
        EM_JAVELIN      = 77,

        [Description("Element 14 64-bit DSP Processor")]
        EM_FIREPATH     = 78,

        [Description("LSI Logic 16-bit DSP Processor")]
        EM_ZSP          = 79,

        [Description("Donald Knuth's educational 64-bit processor")]
        EM_MMIX         = 80,

        [Description("Harvard University machine-independent object files")]
        EM_HUANY        = 81,

        [Description("SiTera Prism")]
        EM_PRISM        = 82
    }
}
